org.jgroups.protocols

## Class MERGE2

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.MERGE2

-     public class MERGE2
      extends Protocol

  Protocol to discover subgroups; e.g., existing due to a network partition (that healed). Example: group {p,q,r,s,t,u,v,w} is split into 3 subgroups {p,q}, {r,s,t,u} and {v,w}. This protocol will eventually send a MERGE event with the coordinators of each subgroup up the stack: {p,r,v}. Note that - depending on the time of subgroup discovery - there could also be 2 MERGE events, which first join 2 of the subgroups, and then the resulting group to the last subgroup. The real work of merging the subgroups into one larger group is done somewhere above this protocol (typically in the GMS protocol).

  This protocol works as follows:

  - If coordinator: periodically retrieve the initial membership (using the FIND_INITIAL_MBRS event provided e.g. by PING or TCPPING protocols. This list contains {coord,addr} pairs.
  - If there is more than 1 coordinator:
    1. Get all coordinators
    2. Create a MERGE event with the list of coordinators as argument
    3. Send the event up the stack

  Requires: FIND_INITIAL_MBRS event from below
  Provides: sends MERGE event with list of coordinators up the stack

  Author:
    Bela Ban, Oct 16 2001

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `inconsistent_view_threshold`
    `protected long` | `max_interval`
    `protected boolean` | `merge_fast`
    `protected long` | `merge_fast_delay`
    `protected long` | `min_interval`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MERGE2()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `long` | `getMaxInterval()`
    `long` | `getMinInterval()`
    `void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
    `boolean` | `isMergeTaskRunning()`
    `java.util.Vector<java.lang.Integer>` | `requiredDownServices()` List of events that are required to be answered by some layer below.
    `void` | `sendMergeSolicitation()` Discovers members and detects whether we have multiple coordinator.
    `void` | `setMaxInterval(long l)`
    `void` | `setMinInterval(long i)`
    `void` | `startMergeTask()`
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `void` | `stopMergeTask()`
    `java.lang.Object` | `up(Event evt)` An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredUpServices, resetStats, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, start, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### min_interval

          protected long min_interval

    - #### max_interval

          protected long max_interval

    - #### inconsistent_view_threshold

          protected int inconsistent_view_threshold

    - #### merge_fast

          protected boolean merge_fast

    - #### merge_fast_delay

          protected long merge_fast_delay

  - ### Constructor Detail

    - #### MERGE2

          public MERGE2()

  - ### Method Detail

    - #### isMergeTaskRunning

          public boolean isMergeTaskRunning()

    - #### init

          public void init()
                    throws java.lang.Exception

      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### getMinInterval

          public long getMinInterval()

    - #### setMinInterval

          public void setMinInterval(long i)

    - #### getMaxInterval

          public long getMaxInterval()

    - #### setMaxInterval

          public void setMaxInterval(long l)

    - #### requiredDownServices

          public java.util.Vector<java.lang.Integer> requiredDownServices()

      Description copied from class: `Protocol`
      List of events that are required to be answered by some layer below.
      Overrides:
        `requiredDownServices` in class `Protocol`
      Returns:
        Vector (of Integers)

    - #### sendMergeSolicitation

          public void sendMergeSolicitation()

      Discovers members and detects whether we have multiple coordinator. If so, kicks off a merge

    - #### startMergeTask

          public void startMergeTask()

    - #### stopMergeTask

          public void stopMergeTask()

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

    - #### down

          public java.lang.Object down(Event evt)

      Description copied from class: `Protocol`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.
      Overrides:
        `down` in class `Protocol`

    - #### up

          public java.lang.Object up(Event evt)

      Description copied from class: `Protocol`
      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.
      Overrides:
        `up` in class `Protocol`

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.